and are mea
#include <Wire.h>         //This is Arduino's I2C library

int input = 0;
int readdata = 0;
int flowcontrol = 0;
int dataread[2]={0,0};         //this is the users input converted hex which can be used after using datainput1()
int totalHEX = 0;             //this is an 8 bit number in hex which can be used after using datainput1(),
int deviceAddress = 0x34;    //Device address of TCA8418
int GPIO = 31;              //GPIO pin 31 on Arduino MEGA

int command = 0;
int datawrite = 0;


void setup() {
  pinMode(GPIO, OUTPUT);
  digitalWrite(GPIO, LOW);
  Serial.begin(9600);
  Wire.begin();           //This is Arduino's I2C library
  //Serial.println("Press 0 to set GPIO low or press 1 to set GPIO HIGH || enter custom mode by entering 9");
  Serial.println("program has begun");
}

void loop() {

  if (Serial.available()){
    input = userinput();
    
    if (input == 1){
      Serial.println("Configuring the overall set up of device");

      //sets rows and columns to be KP
      Serial.println("Configuring device into keypad mode");
      command = 0x1D;
      for(int i=0; i<3; i++){
      Wire.beginTransmission(deviceAddress);      //send device address
      Wire.write(command);                        //command byte = KP_GPIO2 
      Wire.write(0xFF);                           //sets row0-row7 as a KP
      Wire.endTransmission();                     //required to begin I2C communication and stop condition

      

      Wire.beginTransmission(deviceAddress);
      Wire.write(command);
      Wire.endTransmission(); 
  
      Wire.requestFrom(deviceAddress, 1);
      Wire.endTransmission();

      //if this is true then the transaction did not work
      if(Wire.available()<=0){
        Serial.println("Configuration failure!");
        }
      //this means the transaction worked and the values spit out should match what we programmed earlier
      else{
        Serial.print("Data read from register 0x");
        Serial.println(command, HEX);
        while(Wire.available()){
          Serial.print("0x");
          Serial.println(Wire.read(), HEX);
          }
        Serial.println("--------------------");
        }
        command = command + 1;
        }

//        command =0x03;//sets key lock (want it to be unlocked)
//        Wire.beginTransmission(deviceAddress);
//        Wire.write(command);
//        Wire.write(0x00);       //unlocked keypad
//        Wire.endTransmission();
//        
//        Wire.requestFrom(deviceAddress, 1);
//        Wire.endTransmission();
//        
//        if(Wire.available()<=0){
//          Serial.println("Configuration failure!");
//          }
//        //this means the transaction worked and the values spit out should match what we programmed earlier
//        else{
//          Serial.print("Data read from register 0x");
//          Serial.println(command, HEX);
//          while(Wire.available()){
//            Serial.print("0x");
//            Serial.println(Wire.read(), HEX);
//            }
//          Serial.println("--------------------");
//          }
      
      Serial.println("Configuring Configuration Register to 0x01");
      command = 0x01;
      Wire.beginTransmission(deviceAddress);      //send device address
      Wire.write(command);                        //command byte = Configuration register 
      Wire.write(0x11);                           //sets row0-row7 as a GPIO
      Wire.endTransmission();

      command = 0x01;
      Wire.beginTransmission(deviceAddress);
      Wire.write(command);
      Wire.endTransmission();      
      Wire.requestFrom(deviceAddress, 1);
      Wire.endTransmission();
      delay(10);

      //checks to see if the transaction was successful
      if(Wire.available()<=0){
        Serial.println("Configuration failure!");
        }
      //this means the transaction worked and the values spit out should match what we programmed earlier
      else{
        Serial.print("Data read from register 0x");
        Serial.println(command, HEX);
        while(Wire.available()){
          Serial.print("0x");
          Serial.println(Wire.read(), HEX);
          }
        Serial.println("--------------------");
        }

      
      
/*
      //need to generate GPI event mode registers to include columns 4 5 and 6 into the FIFO
      Serial.println("Configuring device to include columns 4 5 and 6 into FIFO event register to 0x70");
      command = 0x21;
      Wire.beginTransmission(deviceAddress);      //send device address
      Wire.write(command);                        //command byte = KP_GPIO2 
      Wire.write(0x70);                           //sets row0-row7 as a GPIO
      Wire.endTransmission();
      
      Wire.beginTransmission(deviceAddress);
      Wire.write(command);
      Wire.endTransmission();      
      Wire.requestFrom(deviceAddress, 1);
      Wire.endTransmission();
      
      //checks to see if the transaction was successful
      if(Wire.available()<=0){
        Serial.println("Configuration failure!");
        }
      //this means the transaction worked and the values spit out should match what we programmed earlier
      else{
        Serial.print("Data read from register 0x");
        Serial.println(command, HEX);
        while(Wire.available()){
          Serial.print("0x");
          Serial.println(Wire.read(), HEX);
          }
        Serial.println("--------------------");
        }
*/
    }
  else if(input==2){
    Serial.println("Checking how many events are in the event FIFO");

    command = 0x03;
    Wire.beginTransmission(deviceAddress);      //send device address
    Wire.write(command);                        //command byte = KP_GPIO2 
    Wire.write(0x70);                           //sets row0-row7 as a GPIO
    Wire.endTransmission();

    Wire.beginTransmission(deviceAddress);
    Wire.write(command);
    Wire.endTransmission();      
    Wire.requestFrom(deviceAddress, 1);
    Wire.endTransmission();

    //checks to see if the transaction was successful
      if(Wire.available()<=0){
        Serial.println("Configuration failure!");
        }
      //this means the transaction worked and the values spit out should match what we programmed earlier
      else{
        while(Wire.available()){
          int dataread= Wire.read();
          dataread = dataread&0x0F;
          Serial.print("Number of events in FIFO = ");
          Serial.println(dataread, DEC);
          }
        Serial.println("--------------------");
        }
    }
  else if(input==3){
    Serial.println("Reading Event A FIFO");

    command = 0x04;
    Wire.beginTransmission(deviceAddress);
      Wire.write(command);
      Wire.endTransmission();      
      Wire.requestFrom(deviceAddress, 1);
      Wire.endTransmission();
      
      //checks to see if the transaction was successful
      if(Wire.available() <= 0){
        Serial.println("Configuration failure!");
        }
      //this means the transaction worked and the values spit out should match what we programmed earlier
      else{
        Serial.print("Data read from register 0x");
        Serial.println(command, HEX);
        while(Wire.available()){
          Serial.print("0x");
          Serial.println(Wire.read(), HEX);
          }
        Serial.println("--------------------");
        }
    
    }
  else if(input==0){
    digitalWrite(GPIO, LOW);
    Serial.println("GPIO set LOW");
    }
  else if(input==9){
    digitalWrite(GPIO, HIGH);
    Serial.println("GPIO set HIGH");
    }

  }}



















/* 
 
  //code taken from TCA7408
  else if(input==9){ //if 9 is entered you can write to the set registers below
        Serial.print(
          "Device Registers:\n"
                                "------------------Registers to Write to------------------\n"
                                "0x01 - Device ID and Control                 \n"
                                "0x03 - I/O Direction                              \n"
                                "0x05 - Output state                             \n"
                                "0x07 - Output High Impedance                       \n"
                                "0x09 - Input Default State                \n"
                                "0x0B - Pull-up/down Enable               \n"
                                "0x0F - Input Status                          \n"
                                "0x11 - Interrupt Mask                        \n"
                                "0x13 - Interrupt Status                             \n"
                                "--------------------------------------------------\n"
                                );
        Serial.print("\n ----------------------------\n"
                      "[input command byte to send]\n");
        datainput();  //Gets two Hex inputs from User 
        command = totalHEX; //Stores the input value in command variable
        Serial.print("Command byte 0x");
        Serial.println(command, HEX);                   //reprints the input
        Serial.print("\n ----------------------------\n"
                      "[input data byte to write]\n\n");
        datainput();                                   //collect two more Hex inputs to determine data written
        datawrite = totalHEX;
        Serial.print("data to write 0x");
        Serial.println(datawrite, HEX);               //prints data to write into the register

        Wire.beginTransmission(deviceAddress);      //send device address
        Wire.write(command);                        //send the command byte
        Wire.write(datawrite);                      //send data to write into register
        Wire.endTransmission();                     //required to begin I2C communication and stop condition
        Serial.println("I2C transaction has been sent\n"); //note this code does not tell you if an ACK was received, do a read transaction to verify
  }
  else if(input==0){ //if 0 is entered then you are able to read from the set registers below

        Serial.print(
          "Device Registers:\n"
                                "------------------Registers to Read from------------------\n"
                                "0x01 - Device ID and Control                 \n"
                                "0x03 - I/O Direction                              \n"
                                "0x05 - Output state                             \n"
                                "0x07 - Output High Impedance                       \n"
                                "0x09 - Input Default State                \n"
                                "0x0B - Pull-up/down Enable               \n"
                                "0x0F - Input Status                          \n"
                                "0x11 - Interrupt Mask                        \n"
                                "0x13 - Interrupt Status                             \n"
                                "--------------------------------------------------\n"
                                );
        Serial.print("\n ----------------------------\n"
                      "[input command byte to Read]\n");
        datainput();  //Gets two Hex inputs from User 
        command = totalHEX; //Stores the input value in command variable
        Serial.print("Command byte 0x");
        Serial.println(command, HEX);                   //reprints the input
        Serial.print("\n ----------------------------\n");
        Wire.beginTransmission(deviceAddress);
        Wire.write(command);
        Wire.endTransmission();      
        Wire.requestFrom(deviceAddress, 1);
        Wire.endTransmission();
        if (Wire.available()){
          Serial.print("data read is: 0x");
          Serial.println(Wire.read(),HEX);
          }
        else{
          Serial.println("No ACK found");
          }
      }

    else{
      Serial.println("invald input, please try again");
      }
    
    
}
}*/

int userinput(){
  char value = Serial.read();
  Serial.println(value);
  value = value - 48; //ASCII to 0-9 inputs 
  return value;
  delay(50);
  }

int datainput(){
  flowcontrol = 0;
int datacheck[2]={0,0};
  Serial.println("Input 2 characters in HEX then hit enter");
  while(flowcontrol==0){
    delay(50);
    if(Serial.available()==2){
      //when we have 2 inputs from user, we will read and store the inputs
      for(int i=0; i<=1; i++){
        dataread[i]=Serial.read();
        if(dataread[i]<=57 && dataread[i]>=48){
          //need to convert the input into hex
          dataread[i]= dataread[i]-48;
          datacheck[i] = 1;
          }
        else if(dataread[i]<=70 && dataread[i]>=65){
          //need to convert the input into hex
          dataread[i]= dataread[i]-55;
          datacheck[i] = 1;
        }
        else if(dataread[i]<=102 && dataread[i]>=97){
          //need to convert the input into hex
          dataread[i]= dataread[i]-87;
          datacheck[i] = 1;
        }
        else{
          Serial.println("Invalid character input");
          datacheck[i] = 0;
          }
        Serial.print("Input in hex: ");
        Serial.println(dataread[i], DEC);
      }
      if ((datacheck[0]&datacheck[1])==1){
        totalHEX=(dataread[0]<<4)+dataread[1];
        flowcontrol = 1;
      }
    else {
      flowcontrol = 0;
      Serial.println("one more both of the inputs were note valid, enter 2 valid hex inputs again");
      }
    }
    else if(Serial.available()>2){
      Serial.println("too many inputs, Input only 2 characters");
      //need to flush the serial buffer
      while(Serial.available()){
        Serial.read();
        flowcontrol = 0;
        }
      }
    //if else statement for flow control incase any inputs were not acceptable
    
    }
    return 1;
  }
  





















  
